/*


*/

import framebuffer.FrameBuffer;

import java.awt.Color;
import java.util.Properties;
import java.io.FileInputStream;
import java.io.File;
import java.io.IOException;

/**
   Outline of CS 45500 Assignment 1.

*/
public class Hw1_fade
{
   public static void main(String[] args)
   {
      // Use a properties file to find out
      // which PPM files to use as assets.
      final Properties properties = new Properties();
      try
      {
         properties.load(
            new FileInputStream(
               new File("assets.properties")));
      }
      catch (IOException e)
      {
         e.printStackTrace(System.err);
         System.exit(-1);
      }
      final String file_1 = properties.getProperty("file1");
      final String file_2 = properties.getProperty("file2");

      // This framebuffer holds the image that will be embedded
      // within two viewports of the larger framebuffer.
      final FrameBuffer fbEmbedded = new FrameBuffer(file_1);

      /******************************************/

      // Create the larger framebuffer.
      final FrameBuffer fb = new FrameBuffer(1000, 600);

      // Fill the framebuffer it with the checkerboard pattern.
      // Create a viewport and fill it with a flipped copy of the first PPM file.
      // Create another viewport and fill it with another flipped copy of the first PPM file.
      // Draw the striped pattern.
      // Create another viewport that covers the selected region of the framebuffer.
      // Create another viewport to hold a "framed" copy of the selected region.
      // Give this viewport a grayish background color.
      // Create another viewport inside the last one.
      // Copy the selected region's viewport into this last viewport.
      // Load Dumbledore (the second PPM file) into another FrameBuffer.
      // Save a copy of what is supposed to be behind Dumbledore.
      // Create a viewport to hold Dumbledore's faded image.
      // Iteratively blend Dumbledore into the viewport.

      // Dumbledore (the second file asset)
      final FrameBuffer dumbledore = new FrameBuffer(file_2);
      // A copy of what is supposed to be behind Dumbledore.
      final FrameBuffer source = new FrameBuffer(fb.new Viewport(400, 100, 500, 500));
      // The destination viewport that will hold the faded Dumbledore.
      final FrameBuffer.Viewport d = fb.new Viewport(400, 100, 500, 500);

      int count = 0;
      // fade Dumbledore by 1% in each iteration.
      for (float fade = 1.0f; fade >= 0.0f; fade-=0.01f)
      {
         // Use fade to blend Dumbledore into the background.


         /******************************************/
         // Save the resulting image in a file.
         final String savedFileName = String.format("Hw1_fade_%03d.ppm", count);
         fb.dumpFB2File(savedFileName);
         System.err.println("Saved " + savedFileName);
         ++count;
      }
   }
}
